var reApacheRecord 	= /(\d+\.\d+\.\d+\.\d+)\s+.*\[(.*)\]\s+\"(.*)\"\s+(\d+)\s+(\d+|-)\s+\"(.*)\"\s+\"(.*)\"/;

var reGoogleQuery 	= /q=([^&]*)/;
var reGoogleNum 	= /num=(\d+)/;
var reGoogleStart 	= /start=(\d+)/;

var reYahooQuery    = /p=([^&]*)/;
var reYahooNum      = /n=(\d+)/;
var reYahooStart    = /b=(\d+)/;

var rePlus 			= /\+/g;

var reApacheDate    = /\s*(\d+)\/(\w+)\/(\d+):(.*)/;

var rsLog  			= null;
var fso 			= new ActiveXObject("Scripting.FileSystemObject");
var siteSummary 	= null;

/*
	//reApacheRecord
	$1 - ip
	$2 - date
	$3 - request
	$4 - ret code
	$5 - size
	$6 - referrer
	$7 - browser

	//reGoogleQuery
	$1 - query

	//reGoogleNum
	$1 - num of records to show

	//reGoogleStart
	$1 - start of the first record to show (0-based)
	
	//reYahooQuery
	$1 - query
	
	//reYahooNum
	$1 - num of records to show
	
	//reYahooStart
	$1 - start of the first record to show (1-based)

	//reApacheDate
	$1 - date
	$2 - month
	$3 - year
	$4 - time
*/

//Convert value into integer with default value = 0
function ToInt(value)
{
	var result = parseInt(value);
	if (isNaN(result)) result = 0;
	return result;
}

//Rounds value to number of digits
function ToFixed(value, digits)
{
	try
	{
	    value = parseFloat(value).toFixed(digits);
	}
	catch(e) {}
	
	return value;
}

function OnBtnParseClick()
{
	Parse();
}

function OnBtnSummaryClick()
{
	ShowSummary(rsLog);
}

function OnBtnShowKeywordsClick()
{
	ShowKeywords(rsLog, "GoogleSearch, Date");
}

var logFile = null;

function CleanupParse()
{
	logFile.Close();
	logFile = null;
	
	btnParse.innerText = "Parse";
	document.body.style.cursor = "default";
	
	ShowSummary(rsLog);
}

function DoParse()
{
	try
	{
		var rs = rsLog;
		var Counter = 0;
		siteSummary = null;
	    
		while (!logFile.AtEndOfStream)
		{
			var str = logFile.ReadLine();

			var r = str.match(reApacheRecord);
			if (r != null)
			{
				rs.AddNew();
				try
				{
					var fields = rs.Fields;
					fields.Item(0).Value = r[1];

					//Convert Apache date into ADO date
					try
					{
						var rDate = r[2].match(reApacheDate);
						if (rDate != null)
						{
							var d = new Date(rDate[2] + " " + rDate[1] + ", " +
								rDate[3] + " " + rDate[4]);
							if (!isNaN(d)) fields.Item(1).Value = d.getVarDate();
						}
					}
					catch (e) {}

					fields.Item(2).Value = r[3];
					fields.Item(3).Value = ToInt(r[4]);
					fields.Item(4).Value = ToInt(r[5]);
					fields.Item(5).Value = r[6];
					if (fields.Item(5).Value == "-") fields.Item(5).Value = "";
					fields.Item(6).Value = r[7];

					try
					{
						var referrer = r[6];

						//Process google results
						if ((referrer.length > 6) &&
							(referrer.toLowerCase().indexOf("google") >= 0))
						{
							var rQuery = referrer.match(reGoogleQuery);
							if (rQuery != null)
							{
								var query = rQuery[1];

								query = query.replace(rePlus, " ");
								query = decodeURIComponent(query);

								rs.Fields.Item(7).Value = query;

								var gStart = 1, gNum = 10;

								var rStart = referrer.match(reGoogleStart);
								if (rStart != null) gStart = ToInt(rStart[1]) + 1;

								var rNum = referrer.match(reGoogleNum);
								if (rNum != null)
								{
									gNum = ToInt(rNum[1]);
									if (gNum == 0) gNum = 10;
								}

								fields.Item(8).Value = gStart;
								fields.Item(9).Value = gNum;
							}
						}

						//Process yahoo results
						if ((referrer.length > 6) &&
						    (referrer.toLowerCase().indexOf("search.yahoo") >= 0))
						{
							var rQuery = referrer.match(reYahooQuery);
							if (rQuery != null)
							{
								var query = rQuery[1];

								query = query.replace(rePlus, " ");
								query = decodeURIComponent(query);

								rs.Fields.Item(7).Value = query;

								var gStart = 1, gNum = 20;

								var rStart = referrer.match(reYahooStart);
								if (rStart != null) gStart = ToInt(rStart[1]);

								var rNum = referrer.match(reYahooNum);
								if (rNum != null)
								{
									gNum = ToInt(rNum[1]);
									if (gNum == 0) gNum = 10;
								}

								fields.Item(8).Value = gStart;
								fields.Item(9).Value = gNum;
							}
						}
					}
					catch(e) {}

					rs.Update();
				}
				catch(e)
				{
				    rs.CancelUpdate();
				}
			}

			Counter++;
			if (Counter >= 250)
			{
			    btnParse.innerText = "Parsed " + rs.RecordCount + " lines.";
			    window.setInterval("DoParse()", 0);
			    return;
			}
		}
	}
	catch(e)
	{
	    CleanupParse()
	    throw e;
	}
	
	CleanupParse();
}

//Parses log file into ADO in-memory recordset.
function Parse(rs)
{
	headOutput.innerText = "";
	divOutput.innerHTML  = "";

	var fileName = inputFile.value;
	if (!(typeof(fileName) == "string")) return;
	
	if (!fso.FileExists(fileName))
	{
	    window.alert("File " + fileName + " does not exists.");
	    return;
	}

	if (rsLog != null && rsLog.State != 0 /*adStateClosed*/) rsLog.Close();
	rsLog = new ActiveXObject("ADODB.Recordset");
	var rs = rsLog;

	//Add fields to recordset
	rs.Fields.Append("IP", 202 /*adVarWChar*/, 15, 0x24 /*adFldIsNullable | adFldUpdatable*/);
	rs.Fields.Append("Date", 7 /*adDate*/, 0, 0x24);
	rs.Fields.Append("Request", 202, 255, 0x24);
	rs.Fields.Append("RetCode", 3 /*adInteger*/, 0, 0x24);
	rs.Fields.Append("Size", 3, 0, 0x24);
	rs.Fields.Append("Referrer", 202, 1024, 0x24);
	rs.Fields.Append("Browser", 202, 1024, 0x24);
	rs.Fields.Append("GoogleSearch", 202, 512, 0x24);
	rs.Fields.Append("GooglePositionFrom", 3, 0, 0x24);
	rs.Fields.Append("GooglePositionCount", 3, 0, 0x24);
	rs.Open();

	logFile = fso.OpenTextFile(fileName, 1);  //For reading
	document.body.style.cursor = "wait";
	window.setInterval("DoParse()", 0);
}

//Returns default table name - uses file name and replaces '.' with ' '
function GetTableName()
{
	var fileName = inputFile.value;
	var tblName  = fso.GetFileName(fileName);
	tblName = tblName.replace(/\./g, ' ');
	return tblName;
}

//Returns number of unique visitors - calculates number of unique IP.
function GetUniqueVisitorsCount(rs)
{
	var result = 0;
	if (rs == null || rs.RecordCount == 0) return 0;
	
	rs.Filter = "";
	rs.Sort = "IP";
	
	var IP = "";
	var prevIP = "";
	
	rs.MoveFirst();
	while (!rs.EOF)
	{
		IP = rs.Fields.Item("IP").Value;
		if (typeof(IP) == "string")
		{
		    if (IP != prevIP)
			{
				result++;
		    	prevIP = IP;
			}
		}
	    rs.MoveNext();
	}
	
	return result;
}

//Returns count of file requests per visitor including images etc.
function GetViewsPerVisitor(rs, VisitorsCount)
{
	rs.Filter = "";
	VisitorsCount = parseInt(VisitorsCount);
	if (rs == null || rs.RecordCount == 0 || VisitorsCount == 0) return 0;

	var result = rs.RecordCount/VisitorsCount;
    result = ToFixed(result, 2);

	return result;
}

//Returns count of visitors from Google.
function GetGoogleVisitorsCount(rs, VisitorsCount)
{
	if (rs == null || rs.RecordCount == 0) return 0;

	rs.Sort   = "";
	rs.Filter = "Referrer LIKE '%google%'";
	var GoogleVisitors = rs.RecordCount;

	var strResult = GoogleVisitors;
	if (VisitorsCount > 0)
	{
		var GooglePercent = GoogleVisitors / VisitorsCount * 100;
	    GooglePercent = ToFixed(GooglePercent, 2);
		
		strResult += " (" + GooglePercent + "%)";
	}
	
	return strResult;
}

//Returns count of visitors from Yahoo.
function GetYahooVisitorsCount(rs, VisitorsCount)
{
	if (rs == null || rs.RecordCount == 0) return 0;

	rs.Sort   = "";
	rs.Filter = "Referrer LIKE '%search.yahoo%'";
	var YahooVisitors = rs.RecordCount;

	var strResult = YahooVisitors;
	if (VisitorsCount > 0)
	{
		var YahooPercent = YahooVisitors / VisitorsCount * 100;
	    YahooPercent = ToFixed(YahooPercent, 2);

		strResult += " (" + YahooPercent + "%)";
	}

	return strResult;
}

//Returns common traffic
function GetTraffic(rs)
{
	if (rs == null || rs.RecordCount == 0) return 0;
	
	rs.Filter = "";
	
	var result = 0;
	var size;
	
	rs.MoveFirst();
	while (!rs.EOF)
	{
	    size = parseInt(rs.Fields.Item("Size").Value);
	    if (!isNaN(size)) result += size;
	    
	    rs.MoveNext();
	}
	
	result = result/1048576; //1MB;
    result = ToFixed(result, 3);
	
	return result + " MB";
}

//Returns number of users who downloaded .exe or .zip file
function GetDownloads(rs)
{
	if (rs == null || rs.RecordCount == 0) return 0;

	rs.Filter = "Request LIKE '%.exe%' OR Request LIKE '%.zip%'";
	rs.Sort = 'IP';
	if (rs.RecordCount == 0) return;
	
	var result = 0;
	var lastIP = "";
	
	rs.MoveFirst();
	while (!rs.EOF)
	{
	    if (lastIP != rs.Fields("IP").Value)
		{
		    lastIP = rs.Fields("IP").Value;
		    result++;
		}
		
		rs.MoveNext();
	}
	
	return result;
}

function GetFirstDate(rs)
{
	if (rs == null || rs.RecordCount == 0) return 0;
	rs.Filter = "Date <> NULL";
	rs.Sort = "Date";
	
	if (rs.RecordCount > 0)
	{
	    rs.MoveFirst();
		return rs.Fields.Item("Date").Value;
	}
	else
	    return "";
}

function GetLastDate(rs)
{
	if (rs == null || rs.RecordCount == 0) return 0;
	rs.Filter = "Date <> NULL";
	rs.Sort = "Date";

	if (rs.RecordCount > 0)
	{
	    rs.MoveLast();
		return rs.Fields.Item("Date").Value;
	}
	else
	    return "";
}

function CalculateSummary()
{
	if (siteSummary != null) return;
    siteSummary = null;
    siteSummary = new Object();
 	var rs = rsLog;
 	
 	rs.Filter = "";
 	siteSummary.DateFrom        = GetFirstDate(rs);
 	siteSummary.DateTo          = GetLastDate(rs);
    siteSummary.HintsCount 		= rs.RecordCount;
    siteSummary.VisitorsCount 	= GetUniqueVisitorsCount(rs);
    siteSummary.GoogleVisitors 	= GetGoogleVisitorsCount(rs, siteSummary.VisitorsCount);
    siteSummary.YahooVisitors 	= GetYahooVisitorsCount(rs, siteSummary.VisitorsCount);
    siteSummary.ViewsPerVisitor = GetViewsPerVisitor(rs, siteSummary.VisitorsCount);
    siteSummary.Traffic 		= GetTraffic(rs);
    siteSummary.Downloads       = GetDownloads(rs);
}

//Show summary on current log file.
function ShowSummary(rs)
{
	headOutput.innerText = "Log summary:";
	divOutput.innerHTML  = "";
	
	if (rs == null) return;
	
	CalculateSummary();
	if (siteSummary == null) return;

	var strOutput = "<TABLE id=\"tblSummary\" border=\"0\" cols=\"2\">\r\n";
	strOutput += "<TBODY>\r\n";

	rs.Filter = "";
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Date from:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.DateFrom + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Date to:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.DateTo + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Hits count:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.HintsCount + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Unique visitors:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.VisitorsCount + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Visitors from Google:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.GoogleVisitors + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Visitors from Yahoo:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.YahooVisitors + "</TD>\r\n";
	strOutput += "</TR>\r\n";

	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Views per visitor:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.ViewsPerVisitor + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Traffic:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.Traffic + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "<TR>\r\n";
	strOutput += "<TD class=\"tdSummaryCaption\">Unique downloads:</TD>\r\n";
	strOutput += "<TD class=\"tdSummaryValue\">" + siteSummary.Downloads + "</TD>\r\n";
	strOutput += "</TR>\r\n";
	
	strOutput += "</TBODY>\r\n";
	strOutput += "</TABLE>";

 	divOutput.innerHTML = strOutput;
}

//Show keywords for current log files.
function ShowKeywords(rs, sort)
{
	headOutput.innerText = "Google searches:";
	divOutput.innerHTML  = "";

	if (rs == null || rs.RecordCount == 0) return;
	
	rs.Filter = "GoogleSearch <> ''";
	rs.Sort = sort;
	
	var strOutput = "<TABLE id=\"tblKeywords\" border=\"0\" cols=\"2\">\r\n";
	strOutput += "<THEAD>\r\n";
	strOutput += "<TR>\r\n";
	strOutput += "<TH style=\"WIDTH: 60%\"><A onClick=\"ShowKeywords(rsLog, 'GoogleSearch, Date');\">Keyword</A></TH>\r\n";
	strOutput += "<TH style=\"WIDTH: 15%\"><A onClick=\"ShowKeywords(rsLog, 'Date');\">Date</A></TH>\r\n";
	strOutput += "<TH style=\"WIDTH: 10%\"><A onClick=\"ShowKeywords(rsLog, 'GooglePositionFrom, Date');\">Position</A></TH>\r\n";
	strOutput += "<TH style=\"WIDTH: 15%\">View</TH>\r\n";
	strOutput += "</TR>\r\n";
	strOutput += "</THEAD>\r\n";
	strOutput += "<TBODY id=\"tblLogBody\">\r\n";

	if (!(rs.EOF && rs.BOF)) rs.MoveFirst();
	while (!rs.EOF)
	{
		var strKeywords = rs.Fields.Item("GoogleSearch").Value;
		if (typeof(strKeywords) == "string" && strKeywords.length > 0)
		{
	
			var posFrom = rs.Fields.Item("GooglePositionFrom").Value;
			var strPosition = "";
			if (posFrom != null)
			{
				strPosition = posFrom + " - ";
				var posCount = rs.Fields.Item("GooglePositionCount").Value;
				if (posCount != null) strPosition += (posFrom + posCount - 1);
			}
			var strReferrer = rs.Fields.Item("Referrer").Value;
			if (strReferrer == null) strNavigate = "";
			var strDate = new Date(rs.Fields.Item("Date").Value);
			if (isNaN(strDate)) strDate = "";
			else strDate = strDate.toLocaleString();

			var strRow = "<TR>\r\n";
			strRow += "<TD>" + strKeywords + "</TD>\r\n";
			strRow += "<TD>" + strDate + "</TD>\r\n";
			strRow += "<TD>" + strPosition + "</TD>\r\n";
			strRow += "<TD>";
			strRow += "<A href=\"" + strReferrer + "\" target=\"_blank\">Query</A><BR>";
			strRow += "<A href=\"http://inventory.overture.com/d/searchinventory/suggestion/?term=" +
	   			encodeURIComponent(strKeywords) + "\" " +
				"target=\"_blank\">Suggestion</A>";
			strRow += "</TD>\r\n";
			strRow += "</TR>\r\n";
			
			strOutput += strRow;
		}

		rs.MoveNext();
	}
	
	strOutput += "</TBODY>\r\n";
	strOutput += "</TABLE>";
	
 	divOutput.innerHTML = strOutput;
}

var
	cmdExport 			= null;
	elProgress 			= null;
	elProgressDefault 	= "";
	
function CleanupExport()
{
	cmdExport  = null;
	if (elProgress != null) elProgress.innerText = elProgressDefault;
	elProgress = null;

	document.body.style.cursor = "default";
}

function ExportRecords()
{
	try
	{
		var Counter = 0;
		var rs = rsLog;
		var cmd = cmdExport;

		while (!rs.EOF)
		{
			for (i = 0; i < rs.Fields.Count; i++)
			{
				var val = rs.Fields.Item(i).Value;
				//Trim string if it is too long.
				if (typeof(val) == "string" && val.length > cmd.Parameters.Item(i).Size-1)
					val = val.substr(0, cmd.Parameters.Item(i).Size-1);
				cmd.Parameters.Item(i).Value = val;
			}
			cmd.Execute();

			rs.MoveNext();

			Counter++;
			if (Counter >= 100)
			{
			    var percentComplete = rs.AbsolutePosition / rs.RecordCount * 100;
			    percentComplete = ToFixed(percentComplete, 2);

				if (elProgress != null)
			    	elProgress.innerText = "Exporting (" + percentComplete + "%)";

				window.setTimeout("ExportRecords()", 0);
				return;
			}
		}
	}
	catch(e)
	{
	    CleanupExport();
	    throw e;
	}

	CleanupExport();
}

//Saves log file into ADO database, including MS Access db.
function SaveRecordset(rs, conn, btnProgress)
{
	var tblName = GetTableName();
	tblName = window.prompt("Enter table name:", tblName);

	//Create table
	var strCreateTbl = "CREATE TABLE [" + tblName + "] ([IP] VarChar(15), " +
		"[Date] DateTime, [Request] VarChar(255), [RetCode] Integer, " +
		"[Size] Integer, [Referrer] VarChar(255), [Browser] VarChar(255), " +
		"[GoogleSearch] VarChar(255), [GooglePositionFrom] Integer, " +
		"[GooglePositionCount] Integer)";
	conn.Execute(strCreateTbl);
	
	//Create 2 views for current log.
	var strCreateGoogleView = "CREATE VIEW [Google keywords: " + tblName + "] AS " +
		"SELECT [GoogleSearch], [GooglePositionFrom], [GooglePositionCount], [Referrer] " +
		"FROM [" + tblName + "] WHERE [GoogleSearch] IS NOT NULL";
	var strCreateGoogleView2 = "CREATE VIEW [Google searches: " + tblName + "] AS " +
		"SELECT [GoogleSearch], Count([GoogleSearch]) as [Count] FROM [" + tblName + "] " +
		"WHERE [GoogleSearch] IS NOT NULL GROUP BY [GoogleSearch]";
	try
	{
		conn.Execute(strCreateGoogleView);
		conn.Execute(strCreateGoogleView2);
	}
	catch(e)
	{
		//Do nothing on failure - not all DBMS support views.
	}

	var cmd = new ActiveXObject("ADODB.Command");
	cmd.ActiveConnection = conn;
	cmd.CommandText = "INSERT INTO [" + tblName + "] Values(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
	var param = cmd.CreateParameter("ID", 202, 1, 15);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("Date", 7, 1, 0);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("Request", 202, 1, 255);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("RetCode", 3, 1, 0);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("Size", 3, 1, 0);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("Referrer", 202, 1, 255);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("Browser", 202, 1, 255);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("GoogleSearch", 202, 1, 255);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("GooglePositionFrom", 3, 1, 0);
	cmd.Parameters.Append(param);
	param = cmd.CreateParameter("GooglePositionCount", 3, 1, 0);
	cmd.Parameters.Append(param);
	cmd.Prepared = true;
	
	rs.Sort = "";
	rs.Filter = "";
	rs.MoveFirst();
	
	cmdExport = cmd;
	if (btnProgress != null)
	{
		elProgress = btnProgress;
		elProgressDefault = btnProgress.innerText;
		btnProgress.innerText = "Exporting ...";
	}
	
	document.body.style.cursor = "wait";
	window.setTimeout("ExportRecords()", 0);
}

function OnBtnExportToJetClick()
{
	if (rsLog == null)
	{
		window.alert("Log file is not processed yet.");
		return;
	}

	rsLog.Filter = "";

 	cDialog.Filter = "MS Access database files (*.mdb)|*.mdb";
	cDialog.CancelError = true;
	try
	{
		cDialog.ShowOpen();
	}
	catch(e)
	{
	    return;
	}

	var dbFileName 	= cDialog.FileName;

	var connStr = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + dbFileName;

	if (!fso.FileExists(dbFileName))
	{
		var cat = new ActiveXObject("ADOX.Catalog");
		cat.Create(connStr);
		cat = null;
	}

	var conn = new ActiveXObject("ADODB.Connection");
	conn.Open(connStr);

    SaveRecordset(rsLog, conn, btnExportToJet);
}

function OnBtnExportToADOClick()
{
	if (rsLog == null)
	{
		window.alert("Log file is not processed yet.");
		return;
	}

	rsLog.Filter = "";

	var locator = new ActiveXObject("DataLinks");
	var conn = locator.PromptNew();
	if (conn == null) return;
	conn.Open();

	SaveRecordset(rsLog, conn, btnExportToADO);
}
